SystemOrganization addCategory: #'Xenon-Core-ParseNodes'!
SystemOrganization addCategory: #'Xenon-Core-Types'!
SystemOrganization addCategory: #'Xenon-Core-Exceptions'!
SystemOrganization addCategory: #'Xenon-Core'!

RBProgramNodeVisitor subclass: #XeAnnotator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 3/17/2012 16:01'!
acceptMethodNode: aMethodNode 
	aMethodNode defaultReturnType: #XeVoidType.
	super acceptMethodNode: aMethodNode.
! !

!XeAnnotator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 3/16/2012 01:27'!
acceptPragmaNode: aPragmaNode
	aPragmaNode selector == #returnType: ifTrue: [
		aPragmaNode parent returnType: (aPragmaNode arguments first token value)
		]
	! !

RBProgramNodeVisitor subclass: #XeTranslator
	instanceVariableNames: 'stream'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!XeTranslator class methodsFor: 'instance creation' stamp: 'BernardoContreras 3/16/2012 00:51'!
newFor: aStream 
	^ self new stream: aStream; yourself! !

!XeTranslator methodsFor: 'visitor-double dispatching' stamp: 'BernardoContreras 3/16/2012 00:57'!
acceptMethodNode: aMethodNode
	aMethodNode returnType emitOn: stream.
	stream space.
	stream nextPutAll: aMethodNode selector asString.
	stream nextPutAll: '(){'; cr.
	stream nextPutAll: '}'.
! !

!XeTranslator methodsFor: 'accessing' stamp: 'BernardoContreras 3/16/2012 00:51'!
stream: aStream 
	stream := aStream! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:03'!
defaultReturnType: typename
	self propertyAt: #defaultReturnType put: typename.! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:33'!
hasReturnType
	^ self hasProperty: #returnType! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:35'!
returnType
	^ self hasReturnType
		ifTrue: [ Smalltalk globals at: (properties at: #returnType) ]
		ifFalse: [ Smalltalk globals at: (properties at: #defaultReturnType) ]! !

!RBMethodNode methodsFor: '*xenon-core' stamp: 'BernardoContreras 3/17/2012 16:33'!
returnType: typename
	self hasReturnType
		ifTrue: [ 
			XeTooManyReturnTypesError
				signalForSelector: self selector
				class: 'methodNode methodClass asString'
				returnTypes:
					{(self returnType).
					typename} ]
		ifFalse: [ self propertyAt: #returnType put: typename ]! !

Error subclass: #XeTooManyReturnTypesError
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Exceptions'!

!XeTooManyReturnTypesError commentStamp: 'BernardoContreras 2/27/2012 19:36' prior: 0!
When a selector in a class has defined too many return types.
A selector in a class should have only one return type.

!

!XeTooManyReturnTypesError class methodsFor: 'signaling' stamp: 'BernardoContreras 2/27/2012 19:37'!
signalForSelector: aSelectorName class: aClassName returnTypes: anArray
	| message |
	message := 'Too many return types for method ' , aSelectorName , ' in class ' , aClassName , '. actual types: '
		, anArray asString.
	^ self new
		messageText: message;
		signal! !

Object subclass: #XeMethodNode
	instanceVariableNames: 'methodNode defaultReturnType'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-ParseNodes'!

!XeMethodNode class methodsFor: 'instance creation' stamp: 'BernardoContreras 2/27/2012 02:32'!
newInstanceFor: aMethodNode 
	^ self basicNew initialize: aMethodNode! !

!XeMethodNode methodsFor: 'accessing' stamp: 'BernardoContreras 3/15/2012 22:42'!
defaultReturnType
	| returnTypes |
	returnTypes := self pragmas select: [ :pragma | pragma selector = #returnType: ].
	returnTypes isEmpty
		ifTrue: [ ^ Smalltalk globals at: defaultReturnType ]
		ifFalse: [ 
			returnTypes size = 1
				ifTrue: [ ^ Smalltalk globals at: returnTypes first arguments first token value]
				ifFalse: [ 
					XeTooManyReturnTypesError signalForSelector: methodNode selector class: 'methodNode methodClass asString' returnTypes: returnTypes ] ]! !

!XeMethodNode methodsFor: 'emit code' stamp: 'BernardoContreras 2/27/2012 01:25'!
emitCodeOn: aStream
	self emitDefaultReturnTypeOn: aStream.
	aStream space.
	aStream nextPutAll: methodNode selector asString.
	aStream nextPutAll: '(){'; cr.
	aStream nextPutAll: '}'.
! !

!XeMethodNode methodsFor: 'emit code' stamp: 'BernardoContreras 2/27/2012 01:32'!
emitDefaultReturnTypeOn: aStream 
	self defaultReturnType emitOn: aStream! !

!XeMethodNode methodsFor: 'initialize-release' stamp: 'BernardoContreras 2/27/2012 18:55'!
initialize: aMethodNode 
	methodNode := aMethodNode.
	defaultReturnType := #XeVoidType.
	! !

!XeMethodNode methodsFor: 'accessing' stamp: 'BernardoContreras 3/15/2012 22:27'!
pragmas
	^ methodNode pragmas! !

Object subclass: #XeType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeType commentStamp: 'BernardoContreras 2/27/2012 19:07' prior: 0!
To describe types!

XeType subclass: #XeIntType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeIntType commentStamp: 'BernardoContreras 2/27/2012 18:58' prior: 0!
To describe type int!

!XeIntType class methodsFor: 'emit code' stamp: 'BernardoContreras 2/27/2012 01:38'!
emitOn: aStream 
	aStream nextPutAll: 'int'! !

XeType subclass: #XeVoidType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core-Types'!

!XeVoidType commentStamp: 'BernardoContreras 2/27/2012 18:59' prior: 0!
To describe type void!

!XeVoidType class methodsFor: 'emit code' stamp: 'BernardoContreras 2/27/2012 01:14'!
emitOn: aStream
	aStream nextPutAll: 'void'! !

Object subclass: #Xenon
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xenon-Core'!

!Xenon methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:31'!
annotatorClass
	^ XeAnnotator! !

!Xenon methodsFor: 'private' stamp: 'BernardoContreras 3/15/2012 23:09'!
parserClass
	^ RBParser! !

!Xenon methodsFor: 'accessing' stamp: 'BernardoContreras 3/16/2012 00:37'!
translate: aClass 
	| method stream annotator translator|
	stream := ReadWriteStream on: (String new: 1000).
	method := self parserClass parseMethod: (aClass sourceCodeAt: #main).
	annotator := self annotatorClass new.
	annotator visitNode: method.
	translator := self translatorClass newFor: stream.
	translator visitNode: method.
	^ stream contents! !

!Xenon methodsFor: 'private' stamp: 'BernardoContreras 3/16/2012 00:38'!
translatorClass
	^ XeTranslator! !
